//+------------------------------------------------------------------+
//|                                       TrendEnvelopeCOL_DEM_1.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  DeepSkyBlue
#property indicator_color5  PaleVioletRed
#property indicator_color6  PaleVioletRed
#property indicator_color7  DeepSkyBlue
#property indicator_color8  PaleVioletRed

//
//
//
//
//

extern string _            = "Parameters";
extern int    MA_Per       = 34;
extern int    MA_SiEmSmWe3 = 1 ;
extern int    DEMA_Period  = 21;
extern int    DEMA_Mode    = 1;  
extern int    DEMA_Applied = PRICE_CLOSE;
extern int    LineStyle    = 0;
extern int    LineSize     = 1;

//
//
//
//
//

double UpBufferG[];
double UpBufferR[];
double UpBufferRa[];
double DnBufferG[];
double DnBufferR[];
double DnBufferRa[];
double UpHist[];
double DnHist[];

bool   calculateValue;
string indicatorFileName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,UpBufferG);  SetIndexStyle(0,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(1,UpBufferR);  SetIndexStyle(1,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(2,UpBufferRa); SetIndexStyle(2,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(3,DnBufferG);  SetIndexStyle(3,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(4,DnBufferR);  SetIndexStyle(4,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(5,DnBufferRa); SetIndexStyle(5,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(6,UpHist);     SetIndexStyle(6,DRAW_HISTOGRAM);
   SetIndexBuffer(7,DnHist);     SetIndexStyle(7,DRAW_HISTOGRAM);

         if (_=="calculateValue") { calculateValue = true; return(0); }
      
   indicatorFileName = WindowExpertName();      
   IndicatorShortName("TEDEM Per "+DoubleToStr(MA_Per,0)+", Ma "+DoubleToStr(MA_SiEmSmWe3,0)+")"); 
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][4];
#define trend     0
#define demaValue 1
#define highValue 2
#define lowValue  3

//
//
//
//
//

int start()
{ 
   int i,r,limit,counted_bars=IndicatorCounted();

   if (Bars<=MA_Per ) return(0);
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   if (calculateValue)
   {
      for(i=limit; i>=0; i--) UpBufferR[i] = iMA(NULL,0,DEMA_Period,0,DEMA_Mode,DEMA_Applied,i);
      for(i=limit; i>=0; i--) UpBufferG[i] = iMAOnArray(UpBufferR,0,DEMA_Period,0,DEMA_Mode,i);
      return(0);
   }      
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
   if (work[Bars-limit-1][trend] == -1)
   {
      CleanPoint(limit,UpBufferR,UpBufferRa);
      CleanPoint(limit,DnBufferR,DnBufferRa);
   }
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][demaValue] = iCustom(NULL,0,indicatorFileName,"calculateValue",MA_Per,MA_SiEmSmWe3,DEMA_Period ,DEMA_Mode ,DEMA_Applied,0,i);
      work[r][highValue] = iMA(NULL,0,MA_Per,0,MA_SiEmSmWe3,PRICE_HIGH,i);
      work[r][lowValue]  = iMA(NULL,0,MA_Per,0,MA_SiEmSmWe3,PRICE_LOW ,i);

         UpBufferG[i]   = work[r][highValue];
         DnBufferG[i]   = work[r][lowValue];
         UpBufferR[i]   = EMPTY_VALUE;
         DnBufferR[i]   = EMPTY_VALUE;
         work[r][trend] = work[r-1][trend];

            if (work[r][demaValue]>work[r-1][demaValue]) work[r][trend] =  1;
            if (work[r][demaValue]<work[r-1][demaValue]) work[r][trend] = -1;
            if (work[r][trend] == -1)
            {
               PlotPoint(i,UpBufferR,UpBufferRa,highValue);
               PlotPoint(i,DnBufferR,DnBufferRa,lowValue);
               UpHist[i] = work[r][lowValue];
               DnHist[i] = work[r][highValue];
            }
            else
            {
               UpHist[i] = work[r][highValue];
               DnHist[i] = work[r][lowValue];
            }
   }
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[], int from)
{
   int r=Bars-i-1;
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = work[r  ][from];
                first[i+1] = work[r-1][from];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  work[r  ][from];
                second[i+1] =  work[r-1][from];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = work[r][from];
         second[i] = EMPTY_VALUE;
      }
}